#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include "syssvc/serial.h"
#include "syssvc/syslog.h"
#include "kernel_cfg.h"

#include <stdarg.h>
#include <stdio.h>

#include "webcam.h"
#include "debug.h"

extern void _INIT_IOLIB(void);

void init_debug(intptr_t exinf)
{
	_INIT_IOLIB();

	serial_opn_por(TASK_PORTID);
	serial_ctl_por(TASK_PORTID, (IOCTL_CRLF | IOCTL_FCSND | IOCTL_FCRCV));
	return;
}

#include "typedefine.h"

void charput(_SBYTE c)
{
	serial_wri_dat(TASK_PORTID, (const char_t*)&c, 1);
	return;
}

_SBYTE charget(void)
{
	return 0;
}
