/***********************************************************************/
/*                                                                     */
/*  FILE        :directDRV.c                                           */
/*  DESCRIPTION :LCD direct drive(HYSNC interrupt)                     */
/*  CPU TYPE    :RX62N                                                 */
/*                                                                     */
/***********************************************************************/

//`
#include "iodefine.h"
#include "lcdset.h"
#include "directDRV.h"

#pragma interrupt (Excep_MTU1_TGIA1(vect=121))
#pragma interrupt (Excep_MTU1_TGIB1(vect=122))
#pragma interrupt (Excep_MTU3_TGIA3(vect=129))

void Excep_MTU1_TGIA1(void){}
void Excep_MTU1_TGIB1(void){}

//MTU3_TGIA3荞ݏ֐
//@@@@FȂ
//@^[lFȂ
//@Tv@F
//@@hcountϐŃJEgAVSYNCMADEMAEXDMACNMTU1X^[g
//@@EXDMAC~ADEM~Ǘ
// MTU3 TGIA3
void Excep_MTU3_TGIA3(void)
{ 
	static int hcount = 0;
	
	hcount++;						// CJE^CNg
	switch(hcount){					// CʒuɂeX
	case LCD_VS:					// ԌVSYNCH
		PPG0.NDRL.BYTE = 0x08;
		break;
		
	case LCD_VBP:					// obN|[`Ԍ
		ICU.IR[IR_MTU1_TGIA1].BIT.IR = 0;	// 荞ݗvtONA
		ICU.IR[IR_MTU1_TGIB1].BIT.IR = 0;	// 荞ݗvtONA
		MTU1.TIER.BYTE = 0x03;		// EXDMACNpMTU1̊荞(TGIA)ATGIBEXDMACJn̊OoXJvɎgp
		MTU3.TIORH.BYTE = 0x52;		// DELANeBuŏo͊Jn
		break;

	case LCD_VBP+LCD_VD:			// obN|[`{\Ԍoߌ
		MTU1.TIER.BYTE = 0;			// EXDMACNvpMTU1~
		break;
	case LCD_VBP+LCD_VD+3:			// obN|[`{\ԁ{_~[TCNoߌ
		MTU3.TIORH.BYTE = 0x66;		// DEH̃mANeBu
		break;
	case LCD_VC:					// Ԍoߌ
		PPG0.NDRL.BYTE = 0x00;		// VSYNCL
		EXDMAC0.EDMSAR = (void *)0x04000000;	// EXDAMCď
		EXDMAC0.EDMCRB = LCD_VD;
		EXDMAC0.EDMCNT.BYTE = 1;	// EXDMACN
		hcount = 0;					// JE^0ɖ߂	
		break;
	default:
		break;
	}
}
