/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: test_mutex8.c 1696 2010-01-01 16:01:25Z ertl-hiro $
 */

/* 
 *		~[ebNX̃eXg(8)
 *
 * yeXg̖ړIz
 *
 *  Dx~[ebNXɑ΂āCchg_priɔ~[ebNX֘A
 *  DxύXԗIɃeXgDCchange_priority
 *  mutex_calc_priority̓eɂ͓ݍ܂ȂD
 *
 * yeXgځz
 *
 *	(A) ^XÑx[XDx̕ύXichg_prij
 *		(A-1) Ώۃ^XNsłԂŁC~[ebNXbN
 *			  ȂꍇɁCDxł̗D揇ʂŒɂȂ邱
 *		(A-2) Ώۃ^XNsłԂŁCDx~[ebNX
 *			  Õ~[ebNX݂̂bNĂꍇɁCDx
 *			  ł̗D揇ʂŒɂȂ邱
 *		(A-3) Ώۃ^XNsłԂŁCDx~[ebNX
 *			  bNĂꍇɁCDxł̗D揇ʂς
 *			  
 *		(A-4) Ώۃ^XN҂ԂŁCDx̑҂sɂȂĂ
 *			  C~[ebNXbNĂȂꍇɁCDx
 *			  ύXCDxł̏ŌɂȂ邱
 *		(A-5) Ώۃ^XN҂ԂŁCDx̑҂sɂȂĂ
 *			  CDx~[ebNXȊÕ~[ebNX݂̂b
 *			  NĂꍇɁCDxύXCDx
 *			  ̏ŌɂȂ邱
 *		(A-6) Ώۃ^XN҂ԂŁCDx̑҂sɂȂĂ
 *			  CDx~[ebNXbNĂꍇɁC
 *			  Dxł̏ςȂ
 *	(B) ^XÑx[XDx̕ύXichg_prijE_ILUSEG[
 *		(B-1) Ώۃ^XNbNĂ~[ebNX̏Dx
 *			  Cx[XDx悤ƂCE_ILUSEG[ɂȂ
 *			  
 *		(B-2) Ώۃ^XNDx~[ebNXbNĂĂC
 *			  bNĂ~[ebNX̏DxCx[XD
 *			  x悤ƂȂꍇɂ́CE_ILUSEG[ɂȂȂ
 *			  
 *		(B-3) Ώۃ^XNbN҂Ă~[ebNX̏Dx
 *			  Cx[XDx悤ƂCE_ILUSEG[
 *			  Ȃ邱
 *		(B-4) Ώۃ^XNDx~[ebNX҂łĂCb
 *			  N҂Ă~[ebNX̏DxCx[XD
 *			  x悤ƂȂꍇɂ́CE_ILUSEG[ɂȂȂ
 *			  
 *
 * yeXgڂ̎@z
 *
 *	(A-1)
 *		Dx^XNiTASK1js\Ԃ̎ɁCDx^XN
 *		iTASK5jTASK1Dxchg_priƁCs\Ԃ̑
 *		Dx^XNiTASK4jCD揇ʂႭȂ邱ƂmFD
 *	(A-2)
 *		Dx^XNiTASK1jDx~[ebNXiMTX3jbN
 *		Cs\Ԃ̎ɁCDx^XNiTASK5jTASK1D
 *		xchg_priƁCs\Ԃ̑̒Dx^XNiTASK4j
 *		CD揇ʂႭȂ邱ƂmFD
 *	(A-3)
 *		Dx^XNiTASK1jDx~[ebNXiMTX1jb
 *		NCs\Ԃ̎ɁCDx^XNiTASK5jTASK1
 *		Dxchg_priƁCTASK1̗DxωȂƂmFD
 *		܂Cs\Ԃ̒Dx^XN2iTASK2CTASK3jpӂ
 *		ĂCD揇ʂςȂƂmFD
 *	(A-4)
 *		Dx^XNiTASK1jDx~[ebNXiMTX2j҂
 *		Ă鎞ɁCDx^XNiTASK5jTASK1Dx
 *		chg_priƁCMTX2҂Ă鑼̒Dx^XNiTASK4j
 *		C҂s񒆂ł̏ɂȂ邱ƂmFD
 *	(A-5)
 *		Dx^XNiTASK1jDx~[ebNXiMTX3jbN
 *		CDx~[ebNXiMTX2j҂Ă鎞ɁCDx^
 *		XNiTASK5jTASK1Dxchg_priƁCMTX2҂Ă
 *		鑼̒Dx^XNiTASK4jC҂s񒆂ł̏ς
 *		ȂƂmFD
 *	(A-6)
 *		Dx^XNiTASK1jDx~[ebNXiMTX1jb
 *		NCDx~[ebNXiMTX2j҂Ă鎞ɁCD
 *		x^XNiTASK5jTASK1Dxchg_priƁCTASK1
 *		DxωȂƂmFD܂CMTX2҂Ă钆D
 *		x^XN2iTASK2CTASK3jpӂĂC҂s񒆂ł̏
 *		ςȂƂmFD
 *	(B-1)
 *		Dx^XNiTASK1jDx~[ebNXiMTX1jb
 *		NCs\Ԃ̎ɁCDx^XNiTASK5jTASK1
 *		Dxchg_priƁCE_ILUSEG[ɂȂ邱ƂmFD
 *	(B-2)
 *		(A-3)̃eXgڂŁCchg_priE_ILUSEG[ɂȂȂƂŊmF
 *		łĂD
 *	(B-3)
 *		Dx^XNiTASK2jDx~[ebNXiMTX1j̃b
 *		N҂Ă鎞ɁCDx^XNiTASK5jTASK2Dx
 *		chg_priƁCE_ILUSEG[ɂȂ邱ƂmFD
 *	(B-4)
 *		(A-6)̃eXgڂŁCchg_priE_ILUSEG[ɂȂȂƂŊmF
 *		łĂD
 *
 * ygp\[Xz
 *
 *	TASK1: Dx^XNCC^XNCŏN
 *	TASK2: Dx^XN
 *	TASK3: Dx^XN
 *	TASK4: Dx^XN
 *	TASK5: Dx^XN
 *	MTX1: ~[ebNXiTA_CEILINGC͒Dxj
 *	MTX2: ~[ebNXiTA_CEILINGC͍Dxj
 *	MTX3: ~[ebNXiTA_TPRIj
 *
 * yeXgV[PXz
 *
 *	== TASK1iDxFj==
 *		call(set_bit_func(bit_mutex))
 *	1:	act_tsk(TASK4)
 *	2:	act_tsk(TASK5)
 *	//		FTASK5CFTASK1CFTASK4
 *	== TASK5iDxFj==
 *	3:	chg_pri(TASK1, LOW_PRIORITY)		... (A-1)
 *	//		FTASK5CFTASK4TASK1
 *	4:	slp_tsk()
 *	== TASK4iDxFj==
 *	5:	slp_tsk()
 *	== TASK1ij==
 *	6:	chg_pri(TSK_SELF, TPRI_INI)
 *
 *	7:	loc_mtx(MTX3)
 *	8:	wup_tsk(TASK4)
 *	9:	wup_tsk(TASK5)
 *	//		FTASK5CFTASK1CFTASK4CMTX3FTASK1
 *	== TASK5ij==
 *	10:	chg_pri(TASK1, LOW_PRIORITY)		... (A-2)
 *	//		FTASK5CFTASK4TASK1CMTX3FTASK1
 *	11:	slp_tsk()
 *	== TASK4ij==
 *	12:	slp_tsk()
 *	== TASK1ij==
 *	13:	unl_mtx(MTX3)
 *		chg_pri(TSK_SELF, TPRI_INI)
 *
 *	14:	loc_mtx(MTX1)
 *	15:	act_tsk(TASK2)
 *	16:	dis_dsp()
 *	17:	rot_rdq(MID_PRIORITY)
 *	18:	act_tsk(TASK3)
 *	//		FTASK2TASK1TASK3CMTX1FTASK1
 *	19:	wup_tsk(TASK5)
 *	//		FTASK5CFTASK2TASK1TASK3CMTX1FTASK1
 *	20:	ena_dsp()
 *	== TASK5ij==
 *	21:	chg_pri(TASK1, LOW_PRIORITY)		... (A-3)(B-2)
 *	//		FTASK5CFTASK2TASK1TASK3CMTX1FTASK1
 *		get_pri(TASK1, &tskpri)
 *		assert(tskpri == MID_PRIORITY)
 *	22:	slp_tsk()
 *	//		FTASK2TASK1TASK3CMTX1FTASK1
 *	== TASK2ij==
 *	23:	slp_tsk()
 *	//		FTASK1TASK3CMTX1FTASK1
 *	== TASK1ij==
 *	24:	unl_mtx(MTX1)
 *	//		FTASK3CFTASK1
 *	== TASK3ij==
 *	25:	slp_tsk()
 *	== TASK1ij==
 *	26:	chg_pri(TSK_SELF, TPRI_INI)
 *
 *	27:	wup_tsk(TASK5)
 *	== TASK5ij==
 *	28:	loc_mtx(MTX2)
 *	29:	tslp_tsk(10) -> E_TMOUT
 *	== TASK1ij==
 *	30:	wup_tsk(TASK4)
 *	31:	loc_mtx(MTX2)
 *	== TASK4ij==
 *	32:	loc_mtx(MTX2)
 *	//		MTX2FTASK5TASK1TASK4
 *	//		^CAEg҂
 *	//		FTASK5CMTX2FTASK5TASK1TASK4
 *	== TASK5ij==
 *	33:	chg_pri(TASK1, LOW_PRIORITY)		... (A-4)
 *	//		FTASK5CMTX2FTASK5TASK4TASK1
 *	34:	unl_mtx(MTX2)
 *	//		FTASK5TASK4CMTX2FTASK4TASK1
 *	35:	slp_tsk()
 *	//		FTASK4CMTX2FTASK4TASK1
 *	== TASK4ij==
 *	36:	unl_mtx(MTX2)
 *	//		FTASK1CFTASK4CMTX2FTASK1
 *	== TASK1ij==
 *	37:	unl_mtx(MTX2)
 *	//		FTASK1TASK4
 *	38:	chg_pri(TSK_SELF, TPRI_INI)
 *
 *	39:	loc_mtx(MTX3)
 *	40:	wup_tsk(TASK5)
 *	//		FTASK5CFTASK1CFTASK4CMTX3FTASK1
 *	== TASK5ij==
 *	41:	loc_mtx(MTX2)
 *	42:	tslp_tsk(10) -> E_TMOUT
 *	== TASK1ij==
 *	43:	loc_mtx(MTX2)
 *	== TASK4ij==
 *	44:	loc_mtx(MTX2)
 *	//		MTX2FTASK5TASK1TASK4CMTX3FTASK1
 *	//		^CAEg҂
 *	//		FTASK5CMTX2FTASK5TASK1TASK4CMTX3FTASK1
 *	== TASK5ij==
 *	45:	chg_pri(TASK1, LOW_PRIORITY)		... (A-5)
 *	//		FTASK5CMTX2FTASK5TASK4TASK1CMTX3FTASK1
 *	46:	unl_mtx(MTX2)
 *	//		FTASK5TASK4CMTX2FTASK4TASK1CMTX3FTASK1
 *	47:	slp_tsk()
 *	//		FTASK4CMTX2FTASK4TASK1CMTX3FTASK1
 *	== TASK4ij==
 *	48:	unl_mtx(MTX2)
 *	//		FTASK1CFTASK4CMTX2FTASK1CMTX3FTASK1
 *	== TASK1ij==
 *	49:	unl_mtx(MTX2)
 *	//		FTASK1TASK4CMTX3FTASK1
 *	50:	unl_mtx(MTX3)
 *	//		FTASK1TASK4
 *	51:	ter_tsk(TASK4)
 *	52:	chg_pri(TSK_SELF, TPRI_INI)
 *
 *	53:	loc_mtx(MTX1)
 *	54:	wup_tsk(TASK5)
 *	//		FTASK5CFTASK1CMTX1FTASK1
 *	== TASK5ij==
 *	55:	loc_mtx(MTX2)
 *	56:	tslp_tsk(10) -> E_TMOUT
 *	//		FTASK1CMTX1FTASK1CMTX2FTASK5
 *	== TASK1ij==
 *	57:	wup_tsk(TASK2)
 *	58:	rot_rdq(MID_PRIORITY)
 *	== TASK2ij==
 *	59:	loc_mtx(MTX2)
 *	//		FTASK1CMTX1FTASK1CMTX2FTASK5TASK2
 *	== TASK1ij==
 *	60:	wup_tsk(TASK3)
 *	61:	loc_mtx(MTX2)
 *	//		FTASK3CMTX1FTASK1CMTX2FTASK5TASK2TASK1
 *	== TASK3ij==
 *	62:	loc_mtx(MTX2)
 *	//		MTX1FTASK1CMTX2FTASK5TASK2TASK1TASK3
 *	//		^CAEg҂
 *	//		FTASK5CMTX1FTASK1CMTX2FTASK5TASK2TASK1TASK3
 *	== TASK5ij==
 *	63:	chg_pri(TASK1, LOW_PRIORITY)		... (A-6)(B-4)
 *	//		FTASK5CMTX1FTASK1CMTX2FTASK5TASK2TASK1TASK3
 *		get_pri(TASK1, &tskpri)
 *		assert(tskpri == MID_PRIORITY)
 *	64:	unl_mtx(MTX2)
 *	//		FTASK5TASK2CMTX1FTASK1CMTX2FTASK2TASK1TASK3
 *	65:	slp_tsk()
 *	//		FTASK2CMTX1FTASK1CMTX2FTASK2TASK1TASK3
 *	== TASK2ij==
 *	66:	unl_mtx(MTX2)
 *	//		FTASK1CFTASK2CMTX1FTASK1CMTX2FTASK1TASK3
 *	== TASK1ij==
 *	67:	unl_mtx(MTX2)
 *	//		FTASK3CFTASK1TASK2CMTX1FTASK1CMTX2FTASK3
 *	== TASK3ij==
 *	68:	unl_mtx(MTX2)
 *	//		FTASK3TASK1TASK2CMTX1FTASK1
 *	69:	ext_tsk() -> noreturn
 *	//		FTASK1TASK2CMTX1FTASK1
 *	== TASK1ij==
 *	70:	chg_pri(TSK_SELF, TPRI_INI)
 *	//		FTASK1TASK2CMTX1FTASK1
 *
 *	71:	rot_rdq(MID_PRIORITY)
 *	//		FTASK2TASK1CMTX1FTASK1
 *	== TASK2ij==
 *	72:	loc_mtx(MTX1)
 *	//		FTASK1CMTX1FTASK1TASK2
 *	== TASK1ij==
 *	73:	wup_tsk(TASK5)
 *	//		FTASK5CFTASK1CMTX1FTASK1TASK2
 *	== TASK5ij==
 *	74:	chg_pri(TASK1, HIGH_PRIORITY) -> E_ILUSE	... (B-1)
 *	75:	chg_pri(TASK2, HIGH_PRIORITY) -> E_ILUSE	... (B-3)
 *	76:	ext_tsk() -> noreturn
 *	//		FTASK1CMTX1FTASK1TASK2
 *	== TASK1ij==
 *	77:	unl_mtx(MTX1)
 *	//		FTASK1TASK2CMTX1FTASK2
 *	78:	ext_tsk() -> noreturn
 *	== TASK2ij==
 *	79:	unl_mtx(MTX1)
 *	80:	END
 */

#include <kernel.h>
#include <t_syslog.h>
#include "syssvc/logtask.h"
#include "kernel_cfg.h"
#include "test_lib.h"
#include "test_mutex8.h"

extern ER	bit_mutex(void);

void
task1(intptr_t exinf)
{
	ER		ercd;

	set_bit_func(bit_mutex);

	check_point(1);
	ercd = act_tsk(TASK4);
	check_ercd(ercd, E_OK);

	check_point(2);
	ercd = act_tsk(TASK5);
	check_ercd(ercd, E_OK);

	check_point(6);
	ercd = chg_pri(TSK_SELF, TPRI_INI);
	check_ercd(ercd, E_OK);

	check_point(7);
	ercd = loc_mtx(MTX3);
	check_ercd(ercd, E_OK);

	check_point(8);
	ercd = wup_tsk(TASK4);
	check_ercd(ercd, E_OK);

	check_point(9);
	ercd = wup_tsk(TASK5);
	check_ercd(ercd, E_OK);

	check_point(13);
	ercd = unl_mtx(MTX3);
	check_ercd(ercd, E_OK);

	ercd = chg_pri(TSK_SELF, TPRI_INI);
	check_ercd(ercd, E_OK);

	check_point(14);
	ercd = loc_mtx(MTX1);
	check_ercd(ercd, E_OK);

	check_point(15);
	ercd = act_tsk(TASK2);
	check_ercd(ercd, E_OK);

	check_point(16);
	ercd = dis_dsp();
	check_ercd(ercd, E_OK);

	check_point(17);
	ercd = rot_rdq(MID_PRIORITY);
	check_ercd(ercd, E_OK);

	check_point(18);
	ercd = act_tsk(TASK3);
	check_ercd(ercd, E_OK);

	check_point(19);
	ercd = wup_tsk(TASK5);
	check_ercd(ercd, E_OK);

	check_point(20);
	ercd = ena_dsp();
	check_ercd(ercd, E_OK);

	check_point(24);
	ercd = unl_mtx(MTX1);
	check_ercd(ercd, E_OK);

	check_point(26);
	ercd = chg_pri(TSK_SELF, TPRI_INI);
	check_ercd(ercd, E_OK);

	check_point(27);
	ercd = wup_tsk(TASK5);
	check_ercd(ercd, E_OK);

	check_point(30);
	ercd = wup_tsk(TASK4);
	check_ercd(ercd, E_OK);

	check_point(31);
	ercd = loc_mtx(MTX2);
	check_ercd(ercd, E_OK);

	check_point(37);
	ercd = unl_mtx(MTX2);
	check_ercd(ercd, E_OK);

	check_point(38);
	ercd = chg_pri(TSK_SELF, TPRI_INI);
	check_ercd(ercd, E_OK);

	check_point(39);
	ercd = loc_mtx(MTX3);
	check_ercd(ercd, E_OK);

	check_point(40);
	ercd = wup_tsk(TASK5);
	check_ercd(ercd, E_OK);

	check_point(43);
	ercd = loc_mtx(MTX2);
	check_ercd(ercd, E_OK);

	check_point(49);
	ercd = unl_mtx(MTX2);
	check_ercd(ercd, E_OK);

	check_point(50);
	ercd = unl_mtx(MTX3);
	check_ercd(ercd, E_OK);

	check_point(51);
	ercd = ter_tsk(TASK4);
	check_ercd(ercd, E_OK);

	check_point(52);
	ercd = chg_pri(TSK_SELF, TPRI_INI);
	check_ercd(ercd, E_OK);

	check_point(53);
	ercd = loc_mtx(MTX1);
	check_ercd(ercd, E_OK);

	check_point(54);
	ercd = wup_tsk(TASK5);
	check_ercd(ercd, E_OK);

	check_point(57);
	ercd = wup_tsk(TASK2);
	check_ercd(ercd, E_OK);

	check_point(58);
	ercd = rot_rdq(MID_PRIORITY);
	check_ercd(ercd, E_OK);

	check_point(60);
	ercd = wup_tsk(TASK3);
	check_ercd(ercd, E_OK);

	check_point(61);
	ercd = loc_mtx(MTX2);
	check_ercd(ercd, E_OK);

	check_point(67);
	ercd = unl_mtx(MTX2);
	check_ercd(ercd, E_OK);

	check_point(70);
	ercd = chg_pri(TSK_SELF, TPRI_INI);
	check_ercd(ercd, E_OK);

	check_point(71);
	ercd = rot_rdq(MID_PRIORITY);
	check_ercd(ercd, E_OK);

	check_point(73);
	ercd = wup_tsk(TASK5);
	check_ercd(ercd, E_OK);

	check_point(77);
	ercd = unl_mtx(MTX1);
	check_ercd(ercd, E_OK);

	check_point(78);
	ercd = ext_tsk();

	check_point(0);
}

void
task2(intptr_t exinf)
{
	ER		ercd;

	check_point(23);
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(59);
	ercd = loc_mtx(MTX2);
	check_ercd(ercd, E_OK);

	check_point(66);
	ercd = unl_mtx(MTX2);
	check_ercd(ercd, E_OK);

	check_point(72);
	ercd = loc_mtx(MTX1);
	check_ercd(ercd, E_OK);

	check_point(79);
	ercd = unl_mtx(MTX1);
	check_ercd(ercd, E_OK);

	check_finish(80);

	check_point(0);
}

void
task3(intptr_t exinf)
{
	ER		ercd;

	check_point(25);
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(62);
	ercd = loc_mtx(MTX2);
	check_ercd(ercd, E_OK);

	check_point(68);
	ercd = unl_mtx(MTX2);
	check_ercd(ercd, E_OK);

	check_point(69);
	ercd = ext_tsk();

	check_point(0);
}

void
task4(intptr_t exinf)
{
	ER		ercd;

	check_point(5);
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(12);
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(32);
	ercd = loc_mtx(MTX2);
	check_ercd(ercd, E_OK);

	check_point(36);
	ercd = unl_mtx(MTX2);
	check_ercd(ercd, E_OK);

	check_point(44);
	ercd = loc_mtx(MTX2);
	check_ercd(ercd, E_OK);

	check_point(48);
	ercd = unl_mtx(MTX2);
	check_ercd(ercd, E_OK);

	check_point(0);
}

void
task5(intptr_t exinf)
{
	ER		ercd;
	PRI		tskpri;

	check_point(3);
	ercd = chg_pri(TASK1, LOW_PRIORITY);
	check_ercd(ercd, E_OK);

	check_point(4);
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(10);
	ercd = chg_pri(TASK1, LOW_PRIORITY);
	check_ercd(ercd, E_OK);

	check_point(11);
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(21);
	ercd = chg_pri(TASK1, LOW_PRIORITY);
	check_ercd(ercd, E_OK);

	ercd = get_pri(TASK1, &tskpri);
	check_ercd(ercd, E_OK);
	check_assert(tskpri == MID_PRIORITY);

	check_point(22);
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(28);
	ercd = loc_mtx(MTX2);
	check_ercd(ercd, E_OK);

	check_point(29);
	ercd = tslp_tsk(10);
	check_ercd(ercd, E_TMOUT);

	check_point(33);
	ercd = chg_pri(TASK1, LOW_PRIORITY);
	check_ercd(ercd, E_OK);

	check_point(34);
	ercd = unl_mtx(MTX2);
	check_ercd(ercd, E_OK);

	check_point(35);
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(41);
	ercd = loc_mtx(MTX2);
	check_ercd(ercd, E_OK);

	check_point(42);
	ercd = tslp_tsk(10);
	check_ercd(ercd, E_TMOUT);

	check_point(45);
	ercd = chg_pri(TASK1, LOW_PRIORITY);
	check_ercd(ercd, E_OK);

	check_point(46);
	ercd = unl_mtx(MTX2);
	check_ercd(ercd, E_OK);

	check_point(47);
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(55);
	ercd = loc_mtx(MTX2);
	check_ercd(ercd, E_OK);

	check_point(56);
	ercd = tslp_tsk(10);
	check_ercd(ercd, E_TMOUT);

	check_point(63);
	ercd = chg_pri(TASK1, LOW_PRIORITY);
	check_ercd(ercd, E_OK);

	ercd = get_pri(TASK1, &tskpri);
	check_ercd(ercd, E_OK);
	check_assert(tskpri == MID_PRIORITY);

	check_point(64);
	ercd = unl_mtx(MTX2);
	check_ercd(ercd, E_OK);

	check_point(65);
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(74);
	ercd = chg_pri(TASK1, HIGH_PRIORITY);
	check_ercd(ercd, E_ILUSE);

	check_point(75);
	ercd = chg_pri(TASK2, HIGH_PRIORITY);
	check_ercd(ercd, E_ILUSE);

	check_point(76);
	ercd = ext_tsk();

	check_point(0);
}
