/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2010 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/* FRK-RX62Npwb_t@ */

#ifndef	TOPPERS_STARTER_KIT_H
#define	TOPPERS_STARTER_KIT_H


/*
 *  MCUˑ̓ǂݍ
 */
#include "rx_rxc/rx62n.h"

/*
 *  NbNݒ
 */

/*
 *  VXeNbNICLK(kHz)
 *
 *  CPUCDTCCDMACACETHERCCEDMACCROMCRAMp
 *  
 */
#define FREQ_ICLK  (96000)

/*
 *  NbNPCLK(kHz)
 *
 *  ^C}CVAȂǎӃW[p
 */
#define FREQ_PCLK  (48000)


/*
 *  {[[gݒ
 */
#define BAUD_4800BPS		UINT_C( FREQ_PCLK * 1000 / 32 / 4800 - 1 )
#define BAUD_9600BPS		UINT_C( FREQ_PCLK * 1000 / 32 / 9600 - 1 )
#define BAUD_19200BPS		UINT_C( FREQ_PCLK * 1000 / 32 / 19200 - 1 )
#define BAUD_38400BPS		UINT_C( FREQ_PCLK * 1000 / 32 / 38400 - 1 )
#define BAUD_57600BPS		UINT_C( FREQ_PCLK * 1000 / 32 / 57600 - 1 )
#define BAUD_115200BPS		UINT_C( FREQ_PCLK * 1000 / 32 / 115200 - 1 )

#define UART_BAUDRATE		BAUD_38400BPS

#ifndef SCI0_BPS_SETTING
#define SCI0_BPS_SETTING	UART_BAUDRATE
#endif
#ifndef SCI1_BPS_SETTING
#define SCI1_BPS_SETTING	UART_BAUDRATE
#endif
#ifndef SCI2_BPS_SETTING
#define SCI2_BPS_SETTING	UART_BAUDRATE
#endif
#ifndef SCI3_BPS_SETTING
#define SCI3_BPS_SETTING	UART_BAUDRATE
#endif
#ifndef SCI4_BPS_SETTING
#define SCI4_BPS_SETTING	UART_BAUDRATE
#endif
#ifndef SCI5_BPS_SETTING
#define SCI5_BPS_SETTING	UART_BAUDRATE
#endif
#ifndef SCI6_BPS_SETTING
#define SCI6_BPS_SETTING	UART_BAUDRATE
#endif

/*
 *  NbN\[X
 */
#define UART_CLKSRC			CLK_F1

#endif	/* TOPPERS_STARTER_KIT_H */

 