#include <kernel.h>
#include "kernel_cfg.h"

#include "iodefine.h"
#include "led_ctrl.h"

#define LED_PORT		PORT1.DR.BIT.B5		/* f[^WX^ */
#define LED_PORT_DDR	PORT1.DDR.BIT.B5	/* f[^fBNVWX^ */

void init_led(intptr_t exinf)
{
	LED_PORT = 1;		/* |[g1̑5rbg1ɐݒ */
	LED_PORT_DDR = 1;	/* |[gC̑8rbgo͂ɐݒ */

	return;
}

/* LED_ */
void led_on(void)
{
	LED_PORT = 0;
	return;
}

/* LED */
void led_off(void)
{
	LED_PORT = 1;
	return;
}

/* LED𔽓] */
void led_toggle(void)
{
	LED_PORT ^= 1;
	return;
}

/* LED𕪎Ĕ] */
void led_toggle_div(unsigned int div)
{
	static unsigned int n = 0;

	if(++n >= div)
	{
		n = 0;
		led_toggle();
	}
	return;
}
